controllers/EntradasController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Entradas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EntradasController implements the CRUD actions for Entradas model.
 */
class EntradasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Entradas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Entradas::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'identrada' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Entradas model.
     * @param int $identrada Identrada
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
   
public function actionView($identrada)
{
    $model = $this->findModel($identrada);
    $editModel = new Entradas(); // Modelo para el formulario de edición

    if ($editModel->load(Yii::$app->request->post()) && $editModel->save()) {
        Yii::$app->session->setFlash('success', 'Entrada actualizada correctamente.');
        return $this->redirect(['view', 'identrada' => $editModel->identrada]);
    }

    return $this->render('view', [
        'model' => $model,
        'editModel' => $editModel,
    ]);
}


    /**
     * Creates a new Entradas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Entradas();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            Yii::$app->session->setFlash('success', 'Entrada guardada correctamente.');
            return $this->redirect(['view', 'identrada' => $model->identrada]);
        }

        return $this->render('entradasform', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Entradas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $identrada Identrada
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($identrada)
    {
        $model = $this->findModel($identrada);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'identrada' => $model->identrada]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

  
    /**
 * Deletes an existing Entradas model.
 * If deletion is successful, the browser will be redirected to the 'diario' page.
 * @param int $identrada Identrada
 * @return \yii\web\Response
 * @throws NotFoundHttpException if the model cannot be found
 */
public function actionDelete($identrada)
{
    $model = $this->findModel($identrada);
    $model->delete();

    // Establecer un mensaje de confirmación
    Yii::$app->session->setFlash('success', 'Entrada eliminada correctamente.');

    return $this->redirect(['diario']);
}


    /**
     * Finds the Entradas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $identrada Identrada
     * @return Entradas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($identrada)
    {
        if (($model = Entradas::findOne(['identrada' => $identrada])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
  public function actionContinuar($identrada)
{
    // Redirige al formulario de creación de pensamientos y pasa el ID de la entrada como parámetro GET
    return $this->redirect(['pensamientos/create', 'identrada' => $identrada]);
}

public function actionDiario()
{
    return $this->render('diario');
}


public function actionCheckAndCreate()
{
    $today = date('Y-m-d');
    $existingEntry = Entradas::find()
        ->where(['fechaentrada' => $today])
        ->one();

    if ($existingEntry) {
        return $this->asJson(['exists' => true]);
    } else {
        return $this->asJson(['exists' => false]);
    }
}




}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Entradas;
use app\models\Objetivos;
use kartik\mpdf\Pdf;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        try {
            // Obtengo las entradas de diario más recientes en orden ascendente
            $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_ASC])->limit(6)->all();
        } catch (\Exception $e) {
            Yii::error('Error al recuperar las entradas de diario: ' . $e->getMessage());
            $entradas = [];
        }

        // Llamo a la acción para contar las entradas positivas y negativas
        // $countResult = $this->actionGraficoEntradas();

        return $this->render('index', [
                    'entradas' => $entradas,
                        // 'positivas' => $countResult['positivas'],
                        // 'negativas' => $countResult['negativas'],
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin() {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
                    'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout() {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact() {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
                    'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout() {
        return $this->render('about');
    }

    /* mi primera explotacion de datos con los datos detallados de las ultimas 6 entradas del diario */

    public function actionView($id) {
        // Buscar la entrada por su ID
        $entrada = Entradas::findOne($id);

        // Verificar si la entrada existe
        if (!$entrada) {
            throw new \yii\web\NotFoundHttpException("La entrada con el ID $id no existe.");
        }

        //Cargar los pensamientos asociados a esta entrada
        $pensamientos = $entrada->getCodpens()->all();
        //cargar las emociones asociadas a esta entrada
        $emociones = $entrada->getCodemos()->all();

        $sensaciones = $entrada->getCodsensas()->all();

        return $this->render('vista_detalles', [
                    'entrada' => $entrada,
                    'pensamientos' => $pensamientos,
                    'sensaciones' => $sensaciones,
                    'emociones' => $emociones,
        ]);
    }

    /* Gráfica para obtener las últimas 6 entradas */

    public function actionGraficoEntradas() {
        try {
            // Obtener las entradas de diario más recientes
            $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_ASC])->limit(6)->all();

            //cont para las entradas positivas y negativas
            $positivas = 0;
            $negativas = 0;
            //contar la cantidad de entradas positivas y negativas
            foreach ($entradas as $entrada) {
                $pensamientos = $entrada->getCodpens()->all();
                foreach ($pensamientos as $pensamiento) {
                    if ($pensamiento->positivo == 1) {
                        $positivas++;
                    } else {
                        $negativas++;
                    }
                }
            }
        } catch (\Exception $e) {
            Yii::error('Error al contar las entradas de diario: ' . $e->getMessage());
            $positivas = 0;
            $negativas = 0;
        }

        //retorno un arreglo asociativo con los conteos de entradas positivas y negativas 
        return [
            'positivas' => $positivas,
            'negativas' => $negativas,
        ];
    }

    public function actionInformacion() {

        return $this->render('informacion');
    }

    /* Conteo de pensamientos positivos y negativos(GRÁFICAS) */

    public function actionEstadisticas() {
        // Obtener el recuento de entradas positivas y negativas
        $countResult = $this->actionGraficoEntradas();

        // Renderizar la vista de estadísticas y pasar los datos del gráfico como parámetros
        return $this->render('estadisticas', [
                    'positivas' => $countResult['positivas'],
                    'negativas' => $countResult['negativas'],
        ]);
    }

    /* Lógica que cuenta los objetivos que estan completados y los que no estan completados (PARA LAS GRÁFICAS) */

    public function actionObjetivos() {
        try {
            // Obtener los objetivos más recientes
            $objetivos = Objetivos::find()->orderBy(['fechalimite' => SORT_DESC])->all();

            // Contadores para objetivos completados y no completados
            $completados = 0;
            $noCompletados = 0;

            // Contar la cantidad de objetivos completados y no completados
            foreach ($objetivos as $objetivo) {
                if ($objetivo->completado) {
                    $completados++;
                } else {
                    $noCompletados++;
                }
            }
        } catch (\Exception $e) {
            Yii::error('Error al contar los objetivos: ' . $e->getMessage());
            $completados = 0;
            $noCompletados = 0;
        }

        // Retornar un arreglo asociativo con los conteos de objetivos completados y no completados
        return [
            'completados' => $completados,
            'noCompletados' => $noCompletados,
        ];
    }

    public function actionSobremi() {
        return $this->render('sobremi');
    }

    /* Acción que renderiza los detalles de las entradas */

    public function actionVistaDetalles($fecha) {
        // Validar que la fecha no esté vacía
        if (empty($fecha)) {
            throw new \yii\web\BadRequestHttpException('Fecha no proporcionada.');
        }

        // Buscar la entrada por fecha
        $entrada = Entradas::findOne(['fechaentrada' => $fecha]);

        // Validar que la entrada exista
        if ($entrada === null) {
            throw new \yii\web\NotFoundHttpException('La entrada no existe.');
        }

        // Obtener los pensamientos asociados a esta entrada
        $pensamientos = $entrada->getCodpens()->all();
        // Obtener las emociones asociadas a esta entrada
        $emociones = $entrada->getCodemos()->all();
        // Obtener las sensaciones asociadas a esta entrada
        $sensaciones = $entrada->getCodsensas()->all();

        // Renderizar la vista con los detalles de la entrada, los pensamientos, las emociones y las sensaciones
        return $this->render('vista_detalles', [
                    'entrada' => $entrada,
                    'pensamientos' => $pensamientos,
                    'emociones' => $emociones,
                    'sensaciones' => $sensaciones,
        ]);
    }

    /* Lógica para la creación del PDF */

    public function actionDownloadPdf($id) {
        $entrada = Entradas::findOne($id);
        if (!$entrada) {
            throw new \yii\web\NotFoundHttpException("La entrada con el ID $id no existe.");
        }

        $pensamientos = $entrada->getCodpens()->all();
        $emociones = $entrada->getCodemos()->all();
        $sensaciones = $entrada->getCodsensas()->all();

        // Renderiza la vista para el PDF
        $content = $this->renderPartial('entrada-pdf', [
            'entrada' => $entrada,
            'pensamientos' => $pensamientos,
            'emociones' => $emociones,
            'sensaciones' => $sensaciones,
        ]);

        // Configuración del componente mPDF
        $pdf = new Pdf([
            'mode' => Pdf::MODE_UTF8,
            'format' => Pdf::FORMAT_A4,
            'orientation' => Pdf::ORIENT_PORTRAIT,
            'destination' => Pdf::DEST_BROWSER,
            'content' => $content,
            'options' => ['title' => 'Detalles de la Entrada'],
            'methods' => [
                'SetHeader' => ['Detalles de la Entrada'],
                'SetFooter' => ['{PAGENO}'],
            ],
        ]);

views/site/about.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\ContactForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
/** @var yii\web\View $this */
$this->title = 'My Yii Application';

use yii\helpers\Html;
use yii\helpers\Url;
use yii\web\View;

$this->registerCssFile(Url::to('@web/css/entradasDiario.css'));
$this->registerCssFile(Url::to('@web/css/modalHome.css'));

/* Archivos Js */
$this->registerJsFile(Url::to('@web/js/scrollVisibilidad.js'), ['position' => View::POS_END]);
$this->registerJsFile(Url::to('@web/js/heartBeat.js'));
$this->registerJsFile(Url::to('@web/js/modalHandling.js'), ['position' => View::POS_END]);
?>

<body>
    <div class="tituloHome">
        <div class="background-image">
            <h1 id="pageTitle" class="animated-title">IKIGAI</h1>
            <hr class="linea-larga">
            <p class="subtitulo">"Tu propósito de vida"</p>
        </div>
    </div>

    <div class="contenedor">
        <div class="tarjeta-boton entry">
            <a href="#" id="create-entry-link" data-check-url="<?= Url::to(['entradas/check-and-create']) ?>" data-create-url="<?= Url::to(['entradas/create']) ?>">
                <div class="card-inner heartbeat-animation">
                    <img src="./images/d2.png" alt="Imagen 1">
                    <div class="overlay">
                        <h3>Crear Entrada</h3>
                    </div>
                </div>
            </a>
        </div>
        <div class="tarjeta-boton entry">
            <a href="<?= Url::to(['objetivos/create-custom']) ?>">
                <div class="card-inner heartbeat-animation">
                    <img src="./images/obje.png" alt="Imagen 2">
                    <div class="overlay">
                        <h3>Establecer Objetivo</h3>
                    </div>
                </div>
            </a>
        </div>
        <div class="tarjeta-boton entry">
            <a href="<?= Url::to(['site/estadisticas']) ?>">
                <div class="card-inner heartbeat-animation">
                    <img src="./images/esta.png" alt="Imagen 3">
                    <div class="overlay">
                        <h3>Estadísticas</h3>
                    </div>
                </div>
            </a>
        </div>
    </div>

    <!-- Entradas diario -->
    <div class="site-index">
        <div class="jumbotron entry">
            <h2 class="titulo-entradas">Últimas Entradas de Diario</h2>
        </div>

        <div class="body-content">
            <div class="row">
<?php foreach ($entradas as $entrada): ?>
                    <div class="col-lg-4 entry">
                        <div class="card-container mb-3">
                            <div class="card">
                                <div class="card-header">
                                    <h3 class="title"><?= Html::encode($entrada->titulo) ?></h3>
                                </div>
                                <div class="card-body">
                                    <p><strong>Fecha :</strong> <?= Yii::$app->formatter->asDate($entrada->fechaentrada) ?></p>
                                    <div class="description"><?= Html::decode($entrada->descripcion) ?></div>
    <?= Html::a('Ver detalles', ['site/view', 'id' => $entrada->identrada], ['class' => 'btn btn-primary']) ?>
                                </div>
                            </div>
                        </div>
                    </div>

<?php endforeach; ?>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div id="entryExistsModal" class="modal" style="display: none;">
        <div class="modal-content">
            <span class="close">&times;</span>
            <p class="modal-p">Ya existe una entrada para el día de hoy. No puedes crear una nueva.</p>
            <button id="cancel-btn">Cancelar</button>
        </div>
    </div>
</body>

views/site/login.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\LoginForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/vista_detalles.php
<?php

// Se incluyen los helpers de Yii para trabajar con HTML y URLs
use yii\helpers\Html;
use yii\helpers\Url;

// Registro de archivos CSS específicos para esta vista
$this->registerCssFile(Url::to('@web/css/entradasDiario.css'));
$this->registerCssFile(Url::to('@web/css/vistaDetalles.css'));

// Registro de archivo JS específico para esta vista, ubicado al final de la página
$this->registerJsFile(Url::to('@web/js/entryDetails.js'), ['position' => \yii\web\View::POS_END]);

?>

<!-- Inclusión de la biblioteca de animaciones animate.css desde un CDN -->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/animate.css/4.1.1/animate.min.css">

<!-- Contenedor del título de los detalles de la entrada -->
<div class="detalles_titulo">
    <h1 class="titdet">Detalles de la Entrada</h1>
</div>

<!-- Contenedor de la tarjeta de detalles de la entrada -->
<div class="entry-details2">
    <div class="tarjeta_detalles animate__animated animate__fadeInLeft">
        <div class="card-header">
            <h3>Descripción de la Entrada</h3>
        </div>
        <div class="scrollable-body">
            <div class="card-body">
                <!-- Mostrar el título de la entrada, codificado para evitar inyecciones -->
                <p><strong>Título: </strong><?= Html::encode($entrada->titulo) ?></p>
                <!-- Mostrar la descripción de la entrada, decodificada -->
                <div id="descripcion-texto" class="descripcion"><strong>Descripción: </strong><?= Html::decode($entrada->descripcion) ?></div>
            </div>
        </div>
    </div>
</div>

<!-- Contenedor de los detalles adicionales de la entrada -->
<div class="entry-details">
    <!-- Tarjeta para los pensamientos asociados con la entrada -->
    <div class="tarjeta_detalles animate__animated animate__fadeInLeft">
        <div class="card-header">
            <h3>Pensamientos:</h3>
        </div>
        <div class="scrollable-body">
            <div class="card-body">
                <!-- Iterar sobre cada pensamiento y mostrar sus detalles -->
                <?php foreach ($pensamientos as $pensamiento): ?>
                    <?= Html::encode($pensamiento->texto) ?>
                    <p><?php echo ($pensamiento->intrusivo) ? '<strong>Intrusivo: </strong>Si' : '<strong>Intrusivo:</strong> No'; ?></p>
                    <p><?php echo ($pensamiento->recurrente) ? '<strong>Recurrente:</strong> Si' : '<strong>Recurrente:</strong> No'; ?></p>
                    <p><?php echo ($pensamiento->positivo) ? '<strong>Positivo:</strong> Si' : '<strong>Positivo:</strong> No'; ?></p>
                <?php endforeach; ?>
            </div>
        </div>
    </div>

    <!-- Tarjeta para las emociones asociadas con la entrada -->
    <div class="tarjeta_detalles animate__animated animate__fadeInLeft">
        <div class="card-header">
            <h3>Emociones:</h3>
        </div>
        <div class="scrollable-body">
            <div class="card-body">
                <!-- Iterar sobre cada emoción y mostrar sus detalles -->
                <?php foreach ($emociones as $emocion): ?>
                    <p><strong>Intensidad:</strong> <?= Html::encode($emocion->intensidad) ?></p>
                    <p><?= Html::encode($emocion->texto) ?></p>
                    <p><?php echo ($emocion->agradable) ? '<strong>Agradable:</strong> Si' : '<strong>Agradable:</strong> No'; ?></p>
                    <p><strong>Tipos de Emociones: </strong>
                        <?php
                        // Obtener y mostrar los tipos de emociones
                        $tiposEmociones = $emocion->getTiposemociones()->all();
                        $tiposEmocionesString = '';
                        foreach ($tiposEmociones as $index => $tipoEmocion) {
                            $tiposEmocionesString .= Html::encode($tipoEmocion->tipos);
                            if ($index < count($tiposEmociones) - 1) {
                                $tiposEmocionesString .= ', ';
                            }
                        }
                        echo $tiposEmocionesString;
                        ?>
                    </p>
                <?php endforeach; ?>
            </div>
        </div>
    </div>

    <!-- Tarjeta para las sensaciones asociadas con la entrada -->
    <div class="tarjeta_detalles animate__animated animate__fadeInLeft">
        <div class="card-header">
            <h3>Sensaciones:</h3>
        </div>
        <div class="scrollable-body">
            <div class="card-body">
                <!-- Iterar sobre cada sensación y mostrar sus detalles -->
                <?php foreach ($sensaciones as $sensacion): ?>
                    <div class="sensacion">
                        <?php
                        // Codificar las descripciones para evitar inyecciones
                        $descripcion = Html::encode($sensacion->descripcion);
                        $denominacion = Html::encode($sensacion->denominacion);
                        $localizacioncorporal = Html::encode($sensacion->localizacioncorporal);
                        // Recortar las descripciones largas
                        $descripcionCorta = mb_strimwidth($descripcion, 0, 30, '...');
                        $denominacionCorta = mb_strimwidth($denominacion, 0, 30, '...');
                        $localizacionCorta = mb_strimwidth($localizacioncorporal, 0, 30, '...');
                        ?>

                        <!-- Mostrar descripción de la sensación -->
                        <p>
                            <strong>Descripción:</strong> 
                            <span class="short-description"><?= $descripcionCorta ?></span>
                            <span class="full-description" style="display: none;"><?= $descripcion ?></span>
                            <?php if (strlen($descripcion) > 30): ?>
                                <a href="#" class="toggle-description">Ver más</a>
                            <?php endif; ?>
                        </p>
                        <!-- Mostrar denominación de la sensación -->
                        <p>
                            <strong>Denominación:</strong> 
                            <span class="short-description"><?= $denominacionCorta ?></span>
                            <span class="full-description" style="display: none;"><?= $denominacion ?></span>
                            <?php if (strlen($denominacion) > 30): ?>
                                <a href="#" class="toggle-description">Ver más</a>
                            <?php endif; ?>
                        </p>
                        <!-- Mostrar localización corporal de la sensación -->
                        <p>
                            <strong>Localización Corporal:</strong> 
                            <span class="short-description"><?= $localizacionCorta ?></span>
                            <span class="full-description" style="display: none;"><?= $localizacioncorporal ?></span>
                            <?php if (strlen($localizacioncorporal) > 30): ?>
                                <a href="#" class="toggle-description">Ver más</a>
                            <?php endif; ?>
                        </p>
                    </div>
                <?php endforeach; ?>
            </div>
        </div>
    </div>
</div>

<!-- Contenedor para los botones "Regresar" y "Descargar PDF" -->
<div class="boton-regresar-container">
    <!-- Botón para regresar a la página anterior -->
    <?= Html::a('Regresar', Yii::$app->request->referrer, ['class' => 'btn btn-regresar']) ?>
    <!-- Botón para descargar un PDF de la entrada -->
    <?= Html::a('Descargar PDF', ['site/download-pdf', 'id' => $entrada->identrada], ['class' => 'btn btn-descargar', 'target' => '_blank']) ?>
</div>